program f2003_environment
  implicit none
  character(len=255) :: user, progname, argv
  integer :: stat
  integer :: i, nargs, len

  call get_environment_variable ("USER", user, status=stat)
  select case (stat)
  case (1)
     print *, "USER is not defined in the environment.  Strange..."
  case (2)
     print *, "This processor doesn't support environment variables.  Boooh!"
  case default
     print *, "Hello user " // trim (user) // "!"
  end select

  call get_command_argument (0, progname, status=stat)
  if (stat == 0) then
     print *, "The program's name is " // trim (progname)
  end if

  nargs = command_argument_count ()
  if (nargs == 0) then
     print *, "There were no arguments given to this program."
  else
     print *, "The number of command line arguments is", nargs
     do i = 1, nargs
        call get_command_argument (i, argv, length=len, status=stat)
        print '(" Argument ",i0," is ''",A,"''")', i, argv(:len)
     end do
  end if

end program f2003_environment
