program f2003_intrinsics_1
  implicit none

  character(len=*), parameter :: s = MIN ("a", "0", "C")
  character(len=*), parameter :: t = MAX ("a", "0", "C")
  character(len=*), parameter :: u(3) = (/"a", "0", "C"/)

  real,    allocatable :: a(:)
  logical, allocatable :: m(:)

  if (s /= "0") then
     print *, "Very funny: s =", s
     stop
  end if
  if (t /= "a") then
     print *, "Very funny: t =", t
     stop
  end if
  if (MINVAL (u) /= s) then
     print *, "Bug: MINVAL (u) =", MINVAL (u)
     stop
  end if
  if (MAXVAL (u) /= t) then
     print *, "Bug: MAXVAL (u) =", MAXVAL (u)
     stop
  end if
  if (MINLOC (u,1) /= 2) then
     print *, "Bug: MINLOC (u) =", MINLOC (u)
     stop
  end if
  if (MAXLOC (u,1) /= 1) then
     print *, "Bug: MAXLOC (u) =", MAXLOC (u)
     stop
  end if

  allocate (a(0), m(0))

  if (any ( (/ &
       minloc ( a ), &
       minloc ( a, mask=m ), &
       minloc ( (/ 1   /), mask=(/ .false. /) ), &
       minloc ( (/ 1.0 /), mask=(/ .false. /) ), &
       minloc ( (/ "A" /), mask=(/ .false. /) ), &
       maxloc ( (/ 1   /), mask=(/ .false. /) )  &
       /) /= 0)) then
     print *, "Bug in implementation of MINLOC/MAXLOC"
     stop
  end if

  print *, "Not bad!"
end program f2003_intrinsics_1
