PROGRAM test_f2003
  
  USE, INTRINSIC :: iso_c_binding, ONLY: c_ptr, c_f_pointer

  IMPLICIT NONE

  INCLUDE 'mpif.h'

  INTEGER, PARAMETER :: n = 10

  INTEGER :: ierr = 0, pe0 = 0
  INTEGER :: nsize, pe, pes, i, win, assert

  INTEGER :: ibuffer(n)

  INTEGER, POINTER :: cbuffer(:)

  TYPE(c_ptr) :: buffer

  INTEGER :: nbytes

  INTEGER(MPI_ADDRESS_KIND) :: size, zero = 0_MPI_ADDRESS_KIND 

  CALL mpi_init(ierr)

  CALL mpi_comm_size (MPI_COMM_WORLD, pes, ierr)
  CALL mpi_comm_rank (MPI_COMM_WORLD, pe,  ierr)

  DO i = 1, n
    ibuffer(i) = i+n*pe
  ENDDO

  CALL mpi_type_extent(MPI_INTEGER, nbytes, ierr)

  nsize = n*(pes-1)

  IF (pe == pe0) THEN
    size = INT(nsize*nbytes,MPI_ADDRESS_KIND)
    CALL mpi_alloc_mem (size, mpi_info_null, buffer, ierr)
    CALL c_f_pointer (buffer, cbuffer, (/ nsize /))
    CALL mpi_win_create (cbuffer, size, nbytes, &
         mpi_info_null, mpi_comm_world, win, ierr)
  ELSE
    CALL mpi_win_create (cbuffer, zero, nbytes, &
         mpi_info_null, mpi_comm_world, win, ierr)
  ENDIF

  assert = 0
  CALL mpi_win_fence (assert, win, ierr)

  IF (pe /= pe0) THEN
    size = n*(pe-1)
    CALL mpi_put (ibuffer, n, MPI_INTEGER, pe0, size, n, MPI_INTEGER, &
         win, ierr)
  ENDIF

  assert = 0
  CALL mpi_win_fence (assert, win, ierr)

  IF (pe == pe0) THEN
    WRITE (0,'(10i5)') cbuffer
  ENDIF

  CALL mpi_win_free(win, ierr)

  CALL mpi_finalize (ierr)

END PROGRAM test_f2003
